/* $Id: srw-server.c,v 1.13 2003/05/12 20:49:05 adam Exp $
   Copyright (C) 2002
   Index Data Aps

This file is part of the SRW tools.

See the file COPYING for details.
*/

#include <stdio.h>

#include "soapH.h"

int main (int argc, char **argv)
{
    struct soap soap;
    int m;

    soap_init(&soap);

    soap.bind_flags = SO_REUSEADDR;

    printf("Started SRW 1.0 listener on port 8001\n");
    m = soap_bind(&soap, "localhost", 8001, 10);
    if (m < 0)
    {
        soap_print_fault(&soap, stderr);
    }
    else
    {
        int i;
        for (i = 0; ; i++)
        {
            int s = soap_accept(&soap);
            if (s < 0)
            {
                soap_print_fault(&soap, stderr);
                break;
            }
            else
            {
		soap.namespaces = namespaces;
                soap_serve(&soap);
                soap_end(&soap);
            }
        }
    }
    soap_done(&soap);
    exit (0);
    return 0;
}

int zs__explainRequest (struct soap *soap,
			struct zs__explainResponse *explainResponse)
{
    explainResponse->Explain = "<zeerex></zeerex>";
    return SOAP_OK;
}

int zs__searchRetrieveRequest(struct soap * soap,
                              xsd__string *query,
			      struct xcql__operandType *xQuery,
			      xsd__string *sortKeys,
                              struct xsort__xSortKeysType *xSortKeys,
                              xsd__integer *startRecord,
                              xsd__integer *maximumRecords,
                              xsd__string *recordSchema,
                              xsd__string *recordPacking,
                              struct zs__searchRetrieveResponse *res)
{
    res->numberOfRecords = 42;
    return SOAP_OK;
}

