#!/usr/bin/perl -w

use SOAP::Lite;

my $soap = SOAP::Lite
   -> service('http://www.loc.gov/zing/srw/srw-bindings.wsdl')
   -> proxy('http://bagel.indexdata.dk:8001/marc');

my $method = SOAP::Data->name('searchRetrieveRequest') 
  -> attr({xmlns => 'http://www.loc.gov/zing/srw/v1.0/'});

my @params = (
   SOAP::Data->name(query => 'dc.title = "computer"'),
   SOAP::Data->name(recordSchema => 'MARC21'),
   SOAP::Data->name(startRecord => '1'),
   SOAP::Data->name(maximumRecords => '2'));

my $response = $soap->call($method => @params);

if ($response->match('//diagnostic')) {
	print "Error(s):\n";
	foreach($response->valueof('//diagnostics/diagnostic')) {
		print " code=", $_->{code};
		print ", details=", $_->{details}, "\n";
	}
} else {
	print "Hits: ", $response->valueof('//numberOfRecords'), "\n";
	foreach($response->valueof('//records/record')) {
		print "schema=", $_->{recordSchema}, "\n";
		print "recordData=", $_->{recordData}, "\n";
	}
}
